Loading...
Searching...
No Matches
QGpgME::VerifyOpaqueJob Class Referenceabstract

An abstract base class for asynchronous verification of opaque signatures. More...

`#include <verifyopaquejob.h>`

Inheritance diagram for QGpgME::VerifyOpaqueJob:
[legend]
Collaboration diagram for QGpgME::VerifyOpaqueJob:
[legend]

## Signals

void | result (const GpgME::VerificationResult &result, const QByteArray &plainText, const QString &auditLogAsHtml=QString(), const GpgME::Error &auditLogError=GpgME::Error())
Signals inherited from QGpgME::Job
void | jobProgress (int current, int total)
void | rawProgress (const QString &what, int type, int current, int total)
QGPGME_DEPRECATED void | progress (const QString &what, int current, int total)
void | done ()

## Public Member Functions

void | setProcessAllSignatures (bool processAll)
bool | processAllSignatures () const
void | setInputFile (const QString &path)
QString | inputFile () const
void | setOutputFile (const QString &path)
QString | outputFile () const
virtual GpgME::Error | start (const QByteArray &signedData)=0
virtual void | start (const std::shared_ptr< QIODevice > &signedData, const std::shared_ptr< QIODevice > &plainText=std::shared_ptr< QIODevice >())=0
virtual GpgME::VerificationResult | exec (const QByteArray &signedData, QByteArray &plainText)=0
Public Member Functions inherited from QGpgME::Job
virtual QString | auditLogAsHtml () const
virtual GpgME::Error | auditLogError () const
bool | isAuditLogSupported () const
GpgME::Error | startIt ()
void | startNow ()

## Protected Member Functions

| VerifyOpaqueJob (std::unique_ptr< VerifyOpaqueJobPrivate >, QObject *parent)
Protected Member Functions inherited from QGpgME::Job
| Job (std::unique_ptr< JobPrivate >, QObject *parent)
| Job (QObject *parent)

## Additional Inherited Members

Public Slots inherited from QGpgME::Job
virtual void | slotCancel ()=0
Static Public Member Functions inherited from QGpgME::Job
static GpgME::Context * | context (Job *job)
Protected Attributes inherited from QGpgME::Job
const std::unique_ptr< JobPrivate > | d_ptr

## Detailed Description

An abstract base class for asynchronous verification of opaque signatures.

To use a VerifyOpaqueJob, first obtain an instance from the CryptoBackend implementation, connect the progress() and result() signals to suitable slots and then start the verification with a call to start(). This call might fail, in which case the VerifyOpaqueJob instance will have scheduled it's own destruction with a call to QObject::deleteLater().

Alternatively, the job can be started with startIt() after setting an input file and an output file. If the job is started this way then the backend reads the input and writes the output directly from/to the specified input file and output file. In this case the plainText value of the result signal will always be empty. This direct IO mode is currently only supported for OpenPGP. Note that startIt() does not schedule the job's destruction if starting the job failed.

After result() is emitted, the VerifyOpaqueJob will schedule it's own destruction by calling QObject::deleteLater().

## Member Function Documentation

## exec()

virtual GpgME::VerificationResult QGpgME::VerifyOpaqueJob::exec | ( | const QByteArray & | signedData,
|  | QByteArray & | plainText )

pure virtual

Synchronous version of start

Implemented in QGpgME::QGpgMEVerifyOpaqueJob.

## setInputFile()

void VerifyOpaqueJob::setInputFile | ( | const QString & | path | ) |

Sets the path of the file to verify.

Used if the job is started with startIt().

## setOutputFile()

void VerifyOpaqueJob::setOutputFile | ( | const QString & | path | ) |

Sets the path of the file to write the result to.

Used if the job is started with startIt().

Note
  If a file with this path exists, then the job will fail, i.e. you need to delete an existing file that shall be overwritten before you start the job.

## setProcessAllSignatures()

void VerifyOpaqueJob::setProcessAllSignatures | ( | bool | processAll | ) |

Enables processing of all signatures if processAll is true.

By default, gpg (in batch mode used by GpgME) stops the verification of data signatures when a bad signature is encountered. This can be changed by setting this flag. It's equivalent to setting the context flag "proc-all-sigs".

This is only supported for OpenPGP and requires GnuPG 2.2.45, 2.4.6, or 2.5.1.

## start() [1/2]

virtual GpgME::Error QGpgME::VerifyOpaqueJob::start | ( | const QByteArray & | signedData | ) |

pure virtual

Starts the verification operation. signature contains the signature data, while signedData contains the data over which the signature was made.

Implemented in QGpgME::QGpgMEVerifyOpaqueJob.

## start() [2/2]

virtual void QGpgME::VerifyOpaqueJob::start | ( | const std::shared_ptr< QIODevice > & | signedData,
|  | const std::shared_ptr< QIODevice > & | plainText = std::shared_ptr< QIODevice >() )

pure virtual

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

If plainText is non-null, the plaintext is written there. Otherwise, it will be delivered in the second argument of result().

Implemented in QGpgME::QGpgMEVerifyOpaqueJob.

The documentation for this class was generated from the following files:

- verifyopaquejob.h
- verifyopaquejob.cpp